=== debian/changelog ===
cog (0.4.0-2) unstable; urgency=medium

  * Set the debhelper compatibility level to 12:
    - Get rid of debian/compat.
    - Add build dependency on debhelper-compat.
  * Add upstream metadata file.

 -- Alberto Garcia <berto@igalia.com>  Mon, 03 Feb 2020 14:37:35 +0100

cog (0.4.0-1) experimental; urgency=medium

  * Initial release (Closes: #949476)

 -- Alberto Garcia <berto@igalia.com>  Sat, 25 Jan 2020 20:01:07 +0100
