## cog 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 include(VersioningUtils)
 include(GNUInstallDirs)
 
-set_project_version(0 6 0)
+set_project_version(0 8 0)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -13,7 +13,7 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 3 1 2)
+calculate_library_versions_from_libtool_triple(COGCORE 4 2 3)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
 include(DistTargets)
@@ -135,6 +135,11 @@
     else ()
         set(COG_IM_API_SUPPORTED OFF)
     endif ()
+    if (COG_PLATFORM_FDO AND "${WEB_ENGINE_VERSION}" VERSION_GREATER "2.27.3")
+        set(COG_FDO_WIDGETS_SUPPORTED ON)
+    else ()
+        set(COG_FDO_WIDGETS_SUPPORTED OFF)
+    endif ()
 endif ()
 
 include(CheckCCompilerFlag)
@@ -264,9 +269,29 @@
         )
         add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v1)
         add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v3)
+        target_compile_options(cogcore PRIVATE -DCOG_IM_API_SUPPORTED=1)
+        if (COG_BUILD_PROGRAMS)
+            target_compile_options(cog PRIVATE -DCOG_IM_API_SUPPORTED=1)
+        endif ()
         target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=1)
     else ()
+        target_compile_options(cogcore PRIVATE -DCOG_IM_API_SUPPORTED=0)
+        if (COG_BUILD_PROGRAMS)
+            target_compile_options(cog PRIVATE -DCOG_IM_API_SUPPORTED=0)
+        endif ()
         target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=0)
+    endif ()
+
+    if (COG_FDO_WIDGETS_SUPPORTED)
+        pkg_check_modules(CAIRO IMPORTED_TARGET cairo)
+        target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::CAIRO)
+        target_sources(cogplatform-fdo PRIVATE
+            platform/cog-popup-menu-fdo.c
+            platform/os-compatibility.c
+        )
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=1)
+    else ()
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=0)
     endif ()
 
     # Direct video display extension.
@@ -300,25 +325,3 @@
     pkg_check_modules(COGPLATFORM_DRM_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 libdrm>=2.4.71 gbm>=13.0 egl libinput libudev wayland-server)
 
     set(COGPLATFORM_DRM_INCLUDE_DIRS
-        ${COGPLATFORM_DRM_DEPS_INCLUDE_DIRS}
-    )
-    set(COGPLATFORM_DRM_CFLAGS
-        ${COGPLATFORM_DRM_DEPS_CFLAGS_OTHER}
-    )
-    set(COGPLATFORM_DRM_LDFLAGS
-        ${COGPLATFORM_DRM_DEPS_LDFLAGS}
-    )
-
-    add_library(cogplatform-drm MODULE platform/cog-platform-drm.c)
-    set_property(TARGET cogplatform-drm PROPERTY C_STANDARD 99)
-    target_include_directories(cogplatform-drm PUBLIC ${COGPLATFORM_DRM_INCLUDE_DIRS})
-    target_compile_options(cogplatform-drm PUBLIC ${COGPLATFORM_DRM_CFLAGS})
-    target_link_libraries(cogplatform-drm cogcore ${COGPLATFORM_DRM_LDFLAGS})
-
-    install(TARGETS cogplatform-drm
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        COMPONENT "runtime"
-    )
-endif () # COG_PLATFORM_DRM AND NOT COG_USE_WEBKITGTK
-
-configure_file(core/cog-config.h.in cog-config.h @ONLY)
