=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Alberto Garcia <berto@igalia.com>
 Build-Depends: debhelper-compat (= 12),
                cmake,
+               libcairo-dev,
                libwayland-dev,
                libwpebackend-fdo-1.0-dev,
                libwpewebkit-1.0-dev,
