=== debian/changelog ===
cog (0.8.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Update copyright years.
  * debian/watch:
    - Set version to 4 (fixes older-debian-watch-file-standard).
  * debian/control:
    - Update Standards-Version to 4.5.1 (no changes).

 -- Alberto Garcia <berto@igalia.com>  Wed, 24 Feb 2021 10:57:15 +0100
