=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libwpebackend-fdo-1.0-dev,
                libwpewebkit-1.0-dev,
                wayland-protocols
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/Igalia/cog
 Vcs-Browser: https://salsa.debian.org/berto/cog
