=== debian/changelog ===
cog (0.10.0-2) unstable; urgency=medium

  * debian/control:
    - Build with libwpebackend-fdo-1.0-dev 1.10.0. This enables SHM buffer
      exports.

 -- Alberto Garcia <berto@igalia.com>  Wed, 16 Jun 2021 15:31:16 +0200

cog (0.10.0-1) experimental; urgency=medium

  * New upstream release.
  * debian/control:
    - Add build dependencies on libdrm-dev, libgbm-dev and libinput-dev.
  * debian/install:
    - Install all platform plugins (this version builds two new ones: drm
      and headless).
  * debian/cog.lintian-overrides:
    - Override sharedobject-in-library-directory-missing-soname in all
      plugins
    - Override library-not-linked-against-libc in the headless plugin
      (this is a false positive, this plugin does not use libc symbols)
  * Drop use-fdo-backend.patch.

 -- Alberto Garcia <berto@igalia.com>  Tue, 18 May 2021 23:25:25 +0200
