=== debian/changelog ===
cog (0.10.1-1) unstable; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Wed, 08 Sep 2021 09:33:20 +0200
